<?php

$hostname = $_SERVER["argv"][1];
$port     = $_SERVER["argv"][2];
$dsnid    = $_SERVER["argv"][3];
$guiid    = $_SERVER["argv"][4]; //ping round trip time is calculated with respect to gui node

require_once 'include/xmlrpc.inc';
include_once 'include/functions-rpc.php';

$_RPC_CLIENT = new xmlrpc_client('/', $hostname, $port);


$r = getDSN();

if ($r->faultCode()) {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
  "\nReason: '" . htmlspecialchars($r->faultString());
  return;
}
else{
  $v = $r->value();
  $max = $v->arraysize();
  if($max == 0){
        print "no logs found.\n";
        return;
  }
}

$bc = -1;
$dsnlastseen = -1;

$guilastseen = -1;
$dsnidfound = 0;
$guifound = 0;
for($i = 0; $i < $v->arraysize(); $i++){
        $rec = $v->arraymem($i);
        if($rec->structmem('DSNID')->scalarval() == $dsnid){
                $bc = $rec->structmem('BootCount')->scalarval();
                $dsnlastseen = $rec->structmem('DSNlastSeen')->scalarval();
                $dsnidfound = 1;
                if($guifound)
                        break;
        }
        if($rec->structmem('DSNID')->scalarval() == $guiid){
                $guilastseen = $rec->structmem('DSNlastSeen')->scalarval();
                $guifound = 1;
                if($dsnidfound)
                        break;
        }
}

if($dsnidfound == 0){
        print $dsnid . "not found\n";
        return;
}
if($guifound == 0){
        print $guiid . "(gui node) not found\n";
        return;
}


//print $guilastseen . "- guilastseen\n";
//print $dsnlastseen . "- dsnlastseen\n";
$format = '%Y-%m-%d %T';
$ftime1 = strptime($guilastseen, $format);
$ftime2 = strptime($dsnlastseen, $format);

function timeinsecs($ftime){
        $secs = $ftime['tm_sec']+
                $ftime['tm_min']*60 +
                $ftime['tm_hour']*3600;
        return $secs;
}

$pingrndtriptime = timeinsecs($ftime2) - timeinsecs($ftime1);
if($pingrndtriptime <= 0)
        $pingrndtriptime = 0;
print "pingrndtriptime:" . $pingrndtriptime . " ";
print "bootcount:". $bc . " ";

if ( !function_exists('sys_get_temp_dir') ) //to get the temp directory for storing BootCount
{
   // Based on http://www.phpit.net/
   // article/creating-zip-tar-archives-dynamically-php/2/
   function sys_get_temp_dir()
   {
       // Try to get from environment variable
       if ( !empty($_ENV['TMP']) )
       {
           return realpath( $_ENV['TMP'] );
       }
       else if ( !empty($_ENV['TMPDIR']) )
       {
           return realpath( $_ENV['TMPDIR'] );
       }
       else if ( !empty($_ENV['TEMP']) )
       {
           return realpath( $_ENV['TEMP'] );
       }

       // Detect by creating a temporary file
       else
       {
           // Try to use system's temporary directory
           // as random name shouldn't exist
           $temp_file = tempnam( md5(uniqid(rand(), TRUE)), '' );
           if ( $temp_file )
           {
               $temp_dir = realpath( dirname($temp_file) );
               unlink( $temp_file );
               return $temp_dir;
           }
           else
           {
               return FALSE;
           }
       }
   }
}

$tempdir = sys_get_temp_dir(). "/BootCount";	 //dir for storing last bootcount of BTnodes
$dsnidsplit = split(":", $dsnid);		 //remove ':' and create filename from dsnid
$fname = $tempdir . "/dsn" . $dsnidsplit[0] . $dsnidsplit[1] .
         $dsnidsplit[2] . $dsnidsplit[3] . $dsnidsplit [4] . $dsnidsplit[5];
if(file_exists($tempdir)){		 //check if tempdir has been created to store BootCount data
        if(file_exists($fname)) {   	 // if file exists, check previous value and update
                if(file_get_contents($fname)==$bc) {
                        print "bootcountchange:0\n";           // bootcount not changed
                        return;
                }
                else {
                        print "bootcountchange:1\n";           // bootcount changed
                        file_put_contents($fname, $bc);
                        return;
                }
        }
        else {          
                if (file_put_contents($fname, $bc) == 0) {
                        print "Cannot create file: " . $fname . "\n";
                        return;
                        }
		print "bootcountchange:0\n";		      // first time, the bootcount is assumed to have not changed
                return;
        }
}
else {					//if tempdir doesn't exist, create it
        if(mkdir($tempdir) == FALSE) {
                print "Cannot create directory: " . $tempdir . "\n";
                return;
        }
        if (file_put_contents($fname, $bc) == 0) {
                        print "Cannot create file: " . $fname . "\n";
                        return;
                        }
        print "bootcountchange:0\n";
        return;
}
?>
         