<?php

require_once 'include/xmlrpc.inc';
include_once 'include/functions-rpc.php';
include_once 'rpc-config.php';

// test config
$_CONFIG = array(
	'nummsg' 	=> 100,
	'size'		=> 86,
	'logclass'	=> 20,
	'loglevel'	=> 4,
	'numnodes'	=> $argv[1],
	'interval'	=> $argv[2],
);

function assertDSNsize($size){
	while (1){
		print("checking dsn size ...\n");

		$have = getNumnodes(6, true);
		print("has $have nodes");

		if($have == $size){
			print(" [OK]\n");
			break;
		}
		else{
			print(" [failed]\n");
			sleep(3);
		}
	}
}

print("\nTest Config:\n");
foreach ($_CONFIG as $key => $value){
	print(" - $key = $value\n");
}

if ($argc != 3 or !is_numeric($_CONFIG['numnodes']) or !is_numeric($_CONFIG['interval'])){
	print("\nusage: $argv[0] <num_of_nodes> <interval_ms>\n");
	exit;
}

assertDSNsize($_CONFIG['numnodes']);

print "\ndsn test setup:\n";

#switch off threads
print("- switching off threads.\n");
threadSwitch('logging', 'off');
threadSwitch('dsnping', 'off');
threadSwitch('dsnversion', 'off');
threadSwitch('dsnlocation', 'off');
threadSwitch('dsnproginfo', 'off');
threadSwitch('coninfo', 'off');   
sleep(1);

#set target power off
print("- switching off target power\n");
dsnCommand('all', 'tg set power off');
sleep(1);

#clears the logs
print("- clearing the log.\n");
dsnCommand('all', 'log clear');
sleep(1);

#set verbosity
print("- setting verbosity of class ".$_CONFIG['logclass']." on.\n");
setVerbosity('all', $_CONFIG['logclass'], 31);
sleep(1);

assertDSNsize($_CONFIG['numnodes']);

print("\nstarting test.\n");
$timestart = getServerTime();
print("server time is: $timestart\n");

$testcommand = 	"jaws benchmark {$_CONFIG['logclass']} {$_CONFIG['loglevel']} {$_CONFIG['interval']} ".
				"{$_CONFIG['nummsg']} {$_CONFIG['size']} T_{$_CONFIG['numnodes']}_{$_CONFIG['interval']}"; 
print "sending test command: [$testcommand]\n";
dsnCommand('all', $testcommand);





?>
