<?php

require_once 'include/xmlrpc.inc';
include_once 'include/functions-rpc.php';
include_once 'rpc-config.php';

// test config
$_CONFIG = array(
	'size'		=> 86,
	'logclass'	=> 20,
	'loglevel'	=> 4,
	'verbosity'	=> 'on',
	'numnodes'	=> $argv[1],
	'bt'		=> $argv[2],
	'ba'		=> $argv[3],
	'w'			=> $argv[4],	
	'cycle_max'	=> $argv[5]
);

function assertDSNsize($size){
	$i = 0;
	while ($i<20){
		$i++;
		print("checking dsn size ...\n");

		$have = getNumnodes(6, true);
		print("has $have nodes");

		if($have == $size){
			print(" [OK]\n");
			break;
		}
		else{
			print(" [failed]\n");
			sleep(3);
		}
	}
	if ($i==20){exit("there are not enough nodes there!! Requested nodes: $size, Number of nodes: $have");}
}

print("\nTest Config:\n");
foreach ($_CONFIG as $key => $value){
	print(" - $key = $value\n");
}
print"\n";
if ($argc != 6 or !is_numeric($_CONFIG['numnodes']) or !is_numeric($_CONFIG['bt']) or !is_numeric($_CONFIG['ba']) or !is_numeric($_CONFIG['w']) or !is_numeric($_CONFIG['cycle_max'])){
	print("\nusage: $argv[0] <num_of_nodes> <bt> <ba> <w> <cycle_max>\n");
	exit;
}

assertDSNsize($_CONFIG['numnodes']);

print "\ndsn test setup:\n";

#switch off threads
print("- switching off threads.\n");
threadSwitch('logging', 'on');
threadSwitch('dsnping', 'on');
threadSwitch('dsnversion', 'off');
threadSwitch('dsnlocation', 'off');
threadSwitch('dsnproginfo', 'off');
threadSwitch('coninfo', 'off');   
sleep(1);

#log off

print("- log off \n");
dsnCommand('all', 'log logmask 1 0');
dsnCommand('all', 'log logmask 1 0');
dsnCommand('all', 'log logmask 1 0');
dsnCommand('all', 'log logmask 1 0');
dsnCommand('all', 'log logmask 1 0');

#set target power off
print("- switching off target power\n");
dsnCommand('all', 'tg set power off');
sleep(1);

#clears the logs
print("- clearing the log.\n");
dsnCommand('all', 'log clear');
sleep(1);

#set verbosity
if ($_CONFIG['verbosity']=='on'){
	print("- setting verbosity of class ".$_CONFIG['logclass']." on.\n");
	setVerbosity('all', $_CONFIG['logclass'], 31);
	sleep(1);
}
else{
	print("- switching on thread logging.\n");
	threadSwitch('logging', 'on');	
}

assertDSNsize($_CONFIG['numnodes']);

//$resp = getDSN();
//$v = $resp->value();
//$numnodes = $v->arraysize();
$node = getActivNodes(6, true);

print("\nstarting test.\n");
$timestart = getServerTime();
print("server time is: $timestart\n");

print("\nwaiting 20 sec to send first message.\n");
sleep(20);

if($_CONFIG['w']!=0){
	for ($cycle = 0; $cycle < $_CONFIG['cycle_max']; $cycle++){
	//assertDSNsize($_CONFIG['numnodes']);
		for ($i = 1; $i <= $_CONFIG['numnodes']; $i++){
			//$node = $v->arraymem($i);
			$nodeaddr = $node[$i];//$node->structmem('DSNID')->scalarval();
	
			$testcommand = 	"jbench {$nodeaddr} {$_CONFIG['logclass']} {$_CONFIG['loglevel']} 5 ".
							"{$_CONFIG['ba']} 
	{$_CONFIG['size']} T_{$cycle}_{$_CONFIG['numnodes']}_{$_CONFIG['bt']}_{$_CONFIG['ba']}_{$_CONFIG['cycle_max']}"; 
			print "sending test command: [$testcommand]\n";
			dsnCommand('root', $testcommand);
			sleep($_CONFIG['w']);
		}
		$wait = $_CONFIG['bt']-($_CONFIG['numnodes'] * $_CONFIG['w']);
		if ($wait > 0){
			sleep($wait);
		}
		else {
			print "wait is longer as bt! bt = ".($_CONFIG['numnodes'] * $_CONFIG['w']);
			$_CONFIG['bt'] = ($_CONFIG['numnodes'] * $_CONFIG['w']);
		}

	}
}
else {
	for ($cycle = 0; $cycle < $_CONFIG['cycle_max']; $cycle++){	
		$testcommand = 	"jbench 00:00:00:00:00:00 {$_CONFIG['logclass']} {$_CONFIG['loglevel']} 5 {$_CONFIG['ba']} {$_CONFIG['size']} T_{$cycle}_{$_CONFIG['numnodes']}_{$_CONFIG['bt']}_{$_CONFIG['ba']}_{$_CONFIG['cycle_max']}"; 
			print "sending test command: [$testcommand]\n";
			dsnCommand('root', $testcommand);

			sleep($_CONFIG['bt']);
	}
}




$timeend = getServerTime();
print("\ntest is finsihed!\n");
print("server time is: $timeend\n\n");
$t=900;
sleep($t);
print("waited $t sec before starting eval!\n\n");
//sleep($t);

print("start eval!\n\n\n");

//print ("numnodes: ".$numnodes);
//print("\ncycle: ".$cycle);

$testyield = 0;

//$node = getActivNodes(6, true); 

for ($i = 1; $i <= $_CONFIG['numnodes']; $i++){
	//$node = $v->arraymem($i);
	//$nodeaddr = $node->structmem('DSNID')->scalarval();
	$nodeaddr = $node[$i];
	print $nodeaddr.":  ";
	$yield = 0;	
	for ($cycle = 0; $cycle < $_CONFIG['cycle_max']; $cycle++){
		$resp2 = getDBEvent($nodeaddr, $_CONFIG['logclass'], $_CONFIG['loglevel'], "T_{$cycle}_{$_CONFIG['numnodes']}_{$_CONFIG['bt']}_{$_CONFIG['ba']}_{$_CONFIG['cycle_max']}", $timestart, '9999-12-31 00:00:00', 1000);
		$v2 = $resp2->value();
		$reclog = $v2->arraysize();
		print $reclog."|";
		$yield = $yield + $reclog;
///print"y = ".$yield;
//$node = $v2->arraymem($i);
//$LogText = $node->structmem('LogText')->scalarval();
//print " ".$LogText."\n";
	}
	$totallogsend = $_CONFIG['cycle_max'] * $_CONFIG['ba'];
//print "yield: $yield  sent: $totallogsend";	
	$totalyield = $yield/$totallogsend*100;
	print "  yield = $totalyield %\n";
	$testyield = $testyield + $yield;
}
$testtotallogsend = $_CONFIG['cycle_max'] * $_CONFIG['ba'] * $_CONFIG['numnodes'];
$testyieldtotal = $testyield/$testtotallogsend*100;
print ("\n\ntotal yield = $testyieldtotal %\n");

assertDSNsize($_CONFIG['numnodes']);

print ("\n\nend eval!");
sleep(300);
?>
