<?php

$hostname = $_SERVER["argv"][1];
$port     = $_SERVER["argv"][2];
$dsnid    = $_SERVER["argv"][3];
$user     = $_SERVER["argv"][4];
$pass     = $_SERVER["argv"][5];

require_once 'include/xmlrpc.inc';
include_once 'include/functions-rpc.php';

$_RPC_CLIENT = new xmlrpc_client('/', $hostname, $port);
$_RPC_CLIENT->setCredentials($user, $pass);

$timestart = getServerTime();

dsnCommand('root', "rpcs $dsnid dsn get traffic");

sleep(3);

$v=array();
$v[] = new xmlrpcval($dsnid, "string"); // dsnid
$v[] = new xmlrpcval(":DTR", "string");  // msg
$v[] = new xmlrpcval($timestart, "string");  // timefrom
$v[] = new xmlrpcval("9999-12-31 00:00:00", "string");  // timetil
$v[] = new xmlrpcval("1", "int");  // timetil

$f = new xmlrpcmsg('getRPCS.getRPCS', $v);

$r = $_RPC_CLIENT->send($f); 
$v = $r->value(); // array

if ($r->faultCode()) {
  print "An error occurred:<pre>";
  print "Code: " . htmlspecialchars($r->faultCode()) .
  "\nReason: '" . htmlspecialchars($r->faultString());
}
else{
  $v = $r->value(); // array
  $max = $v->arraysize();
  if($max == 0){
			print "no logs found.\n";
			return;
	       }
}


$rec = $v->arraymem(0); // struct
	$text_temp = $rec->structmem("msg");
	$text = $text_temp->scalarval();

//	output of dsn traffic ':DTR <mac> <in> <out> <dropped>\n'
	$stringarray = split(" ", $text); // split the text using ' '
	$in =  $stringarray[2]; // get <in> 
	$out = $stringarray[3]; // get <out>
	$dropped_temp = $stringarray[4]; // get <dropped>\n
	$dropped = substr($dropped_temp, 0, -1); //remove '\n'
if (is_numeric($in) && is_numeric($out) && is_numeric($dropped))
	print "dropped:" . $dropped . " in:" . $in . " out:" . $out . "\n";
else 
	print "An error occurred: 'in' or 'out' or 'dropped' is not integer\n";
?>
