<?php
//==========================================================================
function dsnCommand($destination, $command){
	global $_RPC_CLIENT;
	
	$args = array(
		new xmlrpcval($destination, 'string'),
		new xmlrpcval($command, 'string'),
	);
	$req = new xmlrpcmsg('dsnCommand.dsnCommand', $args);
	$resp = $_RPC_CLIENT->send($req);
	
	return $resp;
}

//==========================================================================
function getDSN(){
	global $_RPC_CLIENT;
	
	$req = new xmlrpcmsg('getDSN.getDSN');
	$resp = $_RPC_CLIENT->send($req);
	
	return $resp;
}

//==========================================================================
function getServerTime(){
	global $_RPC_CLIENT;
	
	$req = new xmlrpcmsg('getServerTime.getServerTime');
	$resp = $_RPC_CLIENT->send($req);
	
	$time = $resp->value()->scalarval();
	
	return $time;
	
}



//==========================================================================
function threadSwitch($thread, $state){
	global $_RPC_CLIENT;
	
	$args = array(
		new xmlrpcval($thread, 'string'),
		new xmlrpcval($state, 'string'),
	);
	$req = new xmlrpcmsg('threadSwitch.threadSwitch', $args);
	$resp = $_RPC_CLIENT->send($req);
	
	return $resp;
}

//==========================================================================
function setVerbosity($destination, $class, $level){
	global $_RPC_CLIENT;
	
	$args = array(
		new xmlrpcval($destination, 'string'),
		new xmlrpcval($class, 'int'),
		new xmlrpcval($level, 'int'),
	);
	$req = new xmlrpcmsg('dsnVerbosity.dsnVerbosity', $args);
	$resp = $_RPC_CLIENT->send($req);
	
	return $resp;
}

//==========================================================================
function getDBEvent($destination, $class, $level, $filter, $timefrom, $timetill, $nummsg){
	global $_RPC_CLIENT;
	
	$args = array(
		new xmlrpcval($destination, 'string'),
		new xmlrpcval($level, 'int'),
		new xmlrpcval($class, 'int'),
		new xmlrpcval($filter, 'string'),
		new xmlrpcval($timefrom, 'string'),
		new xmlrpcval($timetill, 'string'),
		new xmlrpcval($nummsg, 'int'),
	);
	$req = new xmlrpcmsg('getDBEvent.getDBEvent', $args);
	$resp = $_RPC_CLIENT->send($req);
	
	return $resp;
}

//==========================================================================
function getNumnodes($interval, $sendping, $debug = false){

	if($sendping){
		$lasttime = getServerTime();
		dsnCommand('all', 'dsn ping');
		sleep($interval);
	}
	else{
		$ftime = strptime(getServerTime(), '%Y-%m-%d %T');
		$lasttime = mktime(
			$ftime['tm_hour'],
			$ftime['tm_min'],
			$ftime['tm_sec'],
			1,
			$ftime['tm_yday'] + 1,
			$ftime['tm_year'] + 1900);
		$lasttime -= $interval;
		$lasttime = date('Y-m-d H:i:s', $lasttime);
	}	
	
	$resp = getDSN();

	$v = $resp->value();
	$count = 0;
	for($i = 0; $i < $v->arraysize(); $i++){
		$rec = $v->arraymem($i);
		$lastseen = $rec->structmem('DSNlastSeen')->scalarval();
		if($debug) print("{$rec->structmem('DSNID')->scalarval()} $lastseen >= $lasttime ?");
		if($lastseen >= $lasttime){
			$count++;
			if($debug) print("[ok]\n");
		}
		else{
			if($debug) print("[old]\n");
		}
	}
	return $count;
}

function getActivNodes($interval, $sendping, $debug = false){

	if($sendping){
		$lasttime = getServerTime();
		dsnCommand('all', 'dsn ping');
		sleep($interval);
	}
	else{
		$ftime = strptime(getServerTime(), '%Y-%m-%d %T');
		$lasttime = mktime(
			$ftime['tm_hour'],
			$ftime['tm_min'],
			$ftime['tm_sec'],
			1,
			$ftime['tm_yday'] + 1,
			$ftime['tm_year'] + 1900);
		$lasttime -= $interval;
		$lasttime = date('Y-m-d H:i:s', $lasttime);
	}	
	
	$resp = getDSN();

	$v = $resp->value();
	$count = 0;
	$node = array();
	for($i = 0; $i < $v->arraysize(); $i++){
		$rec = $v->arraymem($i);
		$lastseen = $rec->structmem('DSNlastSeen')->scalarval();
		if($debug) print("{$rec->structmem('DSNID')->scalarval()} $lastseen ");
		if($lastseen >= $lasttime){
			$count++;
			$node[$count] = $rec->structmem('DSNID')->scalarval(); 
			if($debug) print("[ok]\n");
		}
		else{
			if($debug) print("[old]\n");
		}
	}
	return $node;
}
?>
